Package: futile.logger
Type: Package
Title: A Logging Utility for R
Version: 1.4.9
Date: 2025-12-22
Maintainer: Brian Lee Yung Rowe <r@zatonovo.com>
Authors@R: 
  person(given=c("Brian", "Lee", "Yung"), family="Rowe",
    role=c("aut", "cre"), email="r@zatonovo.com")
Depends: R (>= 3.0.0)
Imports: utils, lambda.r (>= 1.1.0), futile.options
Suggests: testit, jsonlite, httr, crayon, rsyslog, glue
Description: Provides a simple yet powerful logging utility. Based loosely on
    log4j, futile.logger takes advantage of R idioms to make logging a
    convenient and easy to use replacement for cat and print statements.
License: LGPL-3
LazyLoad: yes
NeedsCompilation: no
ByteCompile: yes
Collate: 'options.R' 'appender.R' 'constants.R' 'layout.R' 'logger.R'
        'scat.R' 'util.R' 'futile.logger-package.R'
RoxygenNote: 7.1.2
URL: https://github.com/zatonovo/futile.logger
Packaged: 2025-12-22 17:34:15 UTC; brian
Author: Brian Lee Yung Rowe [aut, cre]
Repository: CRAN
Date/Publication: 2025-12-29 08:50:01 UTC
Built: R 4.6.0; ; 2026-04-25 23:53:51 UTC; unix

Package: futile.logger
Type: Package
Title: A Logging Utility for R
Version: 1.4.9
Date: 2025-12-22
Maintainer: Brian Lee Yung Rowe <r@zatonovo.com>
Authors@R: 
  person(given=c("Brian", "Lee", "Yung"), family="Rowe",
    role=c("aut", "cre"), email="r@zatonovo.com")
Depends: R (>= 3.0.0)
Imports: utils, lambda.r (>= 1.1.0), futile.options
Suggests: testit, jsonlite, httr, crayon, rsyslog, glue
Description: Provides a simple yet powerful logging utility. Based loosely on
    log4j, futile.logger takes advantage of R idioms to make logging a
    convenient and easy to use replacement for cat and print statements.
License: LGPL-3
LazyLoad: yes
NeedsCompilation: no
ByteCompile: yes
Collate: 'options.R' 'appender.R' 'constants.R' 'layout.R' 'logger.R'
        'scat.R' 'util.R' 'futile.logger-package.R'
RoxygenNote: 7.1.2
URL: https://github.com/zatonovo/futile.logger
Packaged: 2025-12-22 17:34:15 UTC; brian
Author: Brian Lee Yung Rowe [aut, cre]
Repository: CRAN
Date/Publication: 2025-12-29 08:50:01 UTC

Overview
========
futile.logger is a logging utility for R. Originally built based on log4j, 
the latest version introduces a new API that is more consistent with R idioms.
In practice this means an interface that works equally well in the shell for
interactive use and also in scripts for system use.

The underlying concepts of log4j still exist, e.g. loggers, appenders, and
formatters. There continues to be a hierarchical system for logger. In 
addition, there is now automatic package scoping, which means that packages
are given their own logger namespace so you can interactively turn on and
off logging for specific packages.

Also included is formatting logic to log list objects (which includes 
data.frames) in a smart way.

Usage
=====
Out of the box, the default `ROOT` logger logs to the console with threshold
set to INFO.

```R
flog.info("Hello, %s", "world")

# Put pid in logging in multi-processing
flog.info('%d message', Sys.getpid()) 

# This won't print by default
flog.debug("Goodbye, %s", "world")

# Change the log level to debug and try again
flog.threshold(DEBUG)
flog.debug("Goodbye, %s", "world")

# Keep an alternate logger at WARN
flog.threshold(WARN, name='quiet')

# This won't print since it's using the logger named 'quiet'!
flog.debug("Goodbye, %s", "world", name='quiet')

```

Loggers
-------
A logger is simply a namespace bound to a threshold, an appender, and a
formatter. Loggers are configured automatically whenever they are 
referenced (for example when changing the threshold) inheriting the settings
of the root logger. To explicitly create a logger call `flog.logger()`.

```R
flog.logger("tawny", WARN, appender=appender.file('tawny.log'))
```
Please notice that you shall not set the name as any of the following keywords:   
'TRACE', 'trace', 'DEBUG', 'debug', 'INFO', 'info', 'WARN', 'warn', 'ERROR', 'error', 'FATAL', 'fatal'

To remove a logger, use `flog.remove()`. If no such logger exists,
the command is safely ignored.

```R
flog.remove("tawny")
```

Thresholds
----------
The logger threshold determines what will be logged for a given logger. Use
this function to retrieve and also change this threshold.

```R
# Get the logging threshold for the ROOT logger
flog.threshold()
```

The default logger is ROOT. To change the threshold of a different logger, 
specify the logger argument with a string that represents the logger. Note
that a log.(debug|info|warn|error) command running from a package will
automatically be associated with a logger with the name of the package. This
structure means you can change the log level for a specific package as 
necessary.

```R
# Set root logger to DEBUG level to see all log messages
flog.threshold(DEBUG)
# Suppress log messages below WARN for logger 'quiet'
flog.threshold(WARN, name="quiet")
```

Appenders
---------
An appender defines where output is directed. Typically only one appender is
used per logger, but multiple can be assigned. The package provides the 
following appenders:

+ `appender.console`
+ `appender.file`
+ `appender.tee`
+ `appender.file2`

To change the appenders assigned to a logger, use `flog.appender()`:
```R
# Change the 'quiet' logger to write to a file
flog.appender(appender.file('quiet.log'), 'quiet')
flog.warn("Goodbye, %s", "world", name='quiet')
```

You can create your own appender by defining a function that accepts a single
character argument. It is up to you to define the behavior. For example,
an appender that logs to a URL might look like the following.

```R
url_appender.gen <- function(url) {
  conn <- url(url)
  function(line) {
    conn.write(line)
  }
}
```

Logging hierarchy
-------
We can create python-style logging hierarchy using `appender.file2`. 
Following snippet will write to both `mylog-WARN.log` and `mylog-INFO.log`
```R
flog.appender(appender.file2("mylog-~l.log", console=TRUE), name='mylogger')
flog.warn('msg1', name='mylogger')
```
If we change the threshold to `DEBUG`, it will also write to `mylog-DEBUG.log`. 
```R
flog.threshold(DEBUG, 'mylogger')
flog.warn('msg2', name='mylogger')
```

If set `inherit=FALSE`, will only write to `mylog-WARN.log` 
```R
flog.appender(appender.file2("mylog-~l.log", console=TRUE, inherit=FALSE), name='mylogger')
flog.warn('msg3', name='mylogger')
```
In this scenario, if we use `flog.info`, it will only write to `mylog-INFO.log`.
```R
flog.info('msg4', name='mylogger')
```

Layouts
-------
A layout defines how a log message is printed. The default layout.simple
prints log messages using the following format:
  LEVEL [datetime] Message

The layouts included in the package are:
+ layout.simple - Use a default format
+ layout.simple.parallel - Use a default format with a process id
+ layout.format - Provide a customizable format string
+ layout.tracearg - Dump a variable with its name


What's New
==========
+ Function to wrap a try/catch with logging (ftry)
+ Capture output for print statements (for more complex objects)
+ New layout.tracearg

See the `NEWS.md` file for a detailed list of most recent changes.

# From
# https://github.com/zatonovo/futile.logger/issues/91
.message_to_console <- function(line) {
  msg <- paste(line, collapse="")
  cond <- simpleMessage(msg)
  class(cond) <- c("futile.logger.message", class(cond))
  message(cond)
}

.cat_to_console <- function(line) {
  cat(line, sep='')
}

.get_console_writer <- function() {
  legacy <- Sys.getenv('FUTILE_LOGGER_LEGACY',FALSE)
  if (legacy) { return(.cat_to_console) }
  .message_to_console
}


.write_to_console <- .get_console_writer()

#' Constants for 'futile.logger'
#' 
#' Log level constants and the logger options.
#'
#' The logging configuration is managed by 'logger.options', a function
#' generated by OptionsManager within 'futile.options'.
#' 
#' @name logger.options
#' @aliases FATAL ERROR WARN INFO DEBUG TRACE
#' @usage logger.options(..., simplify = FALSE, update = list())
#' @param ... TODO
#' @param simplify TODO
#' @param update TODO
#' @author Brian Lee Yung Rowe
#' @seealso \code{futile.options}
#' @keywords data
logger.options <- OptionsManager('logger.options')

#' A Logging Utility for R
#' 
#' This package implements a logging system inspired by log4j. The basic idea
#' of layouts, appenders, and loggers is faithful to log4j, while the
#' implementation and idiom is all R. This means that support for hierarchical
#' loggers, custom appenders, custom layouts is coupled with a simple and
#' intuitive functional syntax.
#' 
#' \tabular{ll}{
#' Package: \tab futile.logger\cr
#' Type: \tab Package\cr
#' Version: \tab 1.4.9\cr
#' Date: \tab 2025-12-22\cr
#' License: \tab LGPL-3\cr
#' LazyLoad: \tab yes\cr
#' }
#' 
#' The latest version of futile.logger introduces zero-configuration semantics
#' out of the box. This means that you can use the default configuration as is.
#' It is also easy to interactively change the configuration of the ROOT
#' logger, as well as create new loggers. Since loggers form a hierarchy based
#' on their name, the ROOT logger is the starting point of the hierarchy and
#' always exists. By default the ROOT logger is defined with a simple layout,
#' printing to the console, with an INFO threshold. This means that writing to
#' any logger with a threshold of INFO or higher will write to the console.
#' 
#' All of the logging functions take a format string so it is easy to add
#' arbitrary values to log messages.
#' 
#' > flog.info("This song is just \%s words \%s", 7, "long")
#' 
#' Thresholds range from most verbose to least verbose: TRACE, DEBUG, INFO,
#' WARN, ERROR, FATAL. You can easily change the threshold of the ROOT logger
#' by calling > flog.threshold(TRACE) which changes will print all log messages
#' from every package. To suppress most logging by default but turn on all
#' debugging for a logger 'my.logger', you would execute 
#'
#' > flog.threshold(ERROR)\cr
#' > flog.threshold(TRACE, name='my.logger')
#'
#' Any arbitrary logger can be defined simply by specifying it in any
#' futile.logger write operation (futile.threshold, futile.appender,
#' futile.layout). If the logger hasn't been defined, then it will be defined
#' dynamically. Any unspecified options will be copied from the parent logger.
#' 
#' When writing log messages, futile.logger will search the hierarchy based on
#' the logger name. In our example, if 'my.logger' hasn't been defined then
#' futile.logger will look for a logger named 'my' and finally the ROOT logger.
#' 
#' Functions calling futile.logger from a package are automatically assigned a
#' logger that has the name of the package. Suppose we have log messages in a
#' package called 'my.package'. Then any function that calls futile.logger from
#' within the package will automatically be assigned a default logger of
#' 'my.package' instead of ROOT. This means that it is easy to change the log
#' setting of any package that uses futile.logger for logging by just updating
#' the logger for the given package. For instance suppose you want to output
#' log message for my.package to a file instead.
#' 
#' > flog.appender(appender.file('my.package.log'), name='my.package')
#' 
#' Now all log statements in the package my.package will be written to a file
#' instead of the console. All other log messages will continue to be written
#' to the console.
#' 
#' Appenders do the actual work of writing log messages to a writeable target,
#' whether that is a console, a file, a URL, database, etc. When creating an
#' appender, the implementation-specific options are passed to the appender at
#' instantiation. The package defines two appender generator functions:
#' 
#' \describe{
#'   \item{appender.file}{Write to a file}
#'   \item{appender.console}{Write to the console}
#' }
#' 
#' Each of these functions returns the actual appender function, so be sure to
#' actually call the function!
#' 
#' Layouts are responsible for formatting messages. This operation usually
#' consists of adding the log level, a timestamp, plus some pretty-printing to
#' make the log messages easy on the eyes. The package supplies several layouts:
#' 
#' \describe{
#'   \item{layout.simple}{Writes messages with a default format}
#'   \item{layout.simple.parallel}{Writes messages with a default format with PID}
#'   \item{layout.json}{Generates messages in a JSON format}
#'   \item{layout.format}{Define your own format}
#'   \item{layout.tracearg}{Print a variable name along with its value}
#' }
#' 
#' @name futile.logger-package
#' @aliases futile.logger-package futile.logger flog.namespace
#' @docType package
#' @exportPattern "^[^\\.]"
#' @import utils lambda.r futile.options
#' @author Brian Lee Yung Rowe <r@@zatonovo.com>
#' @seealso \code{\link{flog.logger}}, \code{\link{flog.threshold}},
#' \code{\link{flog.layout}}, \code{\link{flog.appender}}
#' @keywords package attribute logic
#' @examples
#' 
#' flog.debug("This %s print", "won't")
#' flog.warn("This %s print", "will")
#'   
#' flog.info("This inherits from the ROOT logger", name='logger.a')
#' flog.threshold(DEBUG, name='logger.a')
#' flog.debug("logger.a has now been set to DEBUG", name='logger.a')
#' flog.debug("But the ROOT logger is still at INFO (so this won't print)")
#' 
#' \dontrun{
#' flog.appender(appender.file("other.log"), name='logger.b')
#' flog.info("This writes to a %s", "file", name='logger.b')
#' }
#' 
NULL

# This file is automatically sourced by testthat for each test file
# This is best practice for testthat and also enables testing during package development in RStudio
#
# See also:
# https://github.com/zatonovo/futile.logger/issues/99
# https://stackoverflow.com/a/41777777/

get_log_output <- function(expr) {
  o <- evaluate_promise(expr)
  o$message
}

# :vim set ff=R

## record default layout so that we can restore later
default.layout <- flog.layout()

assert("Embedded format string", {
  flog.threshold(INFO)
  raw <- get_log_output(flog.info("This is a %s message", "log"))
  #cat("\n[test.default] Raw:",raw,"\n")
  (length(grep('INFO', raw)) > 0)
  (length(grep('log message', raw)) > 0)
})

assert("layout.simple.parallel layout", {
  flog.threshold(INFO)
  flog.layout(layout.simple.parallel)
  raw <- get_log_output(flog.info("log message"))

  (length(paste0('INFO [[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2} ', Sys.getpid(), '] log message') ==  raw) > 0)
  (length(grep('log message', raw)) > 0)
})

assert("~p token gets correct PID", {
  flog.threshold(INFO)
  flog.layout(layout.format('xxx[~l ~p]xxx'))
  raw <- get_log_output(flog.info("log message"))

  (paste0('xxx[INFO ',Sys.getpid(),']xxx\n') == raw)
  (length(grep('log message', raw)) == 0)
})

assert("~i token (logger name)", {
  flog.threshold(INFO)
  flog.layout(layout.format('<~i> ~m'))
  # with no logger name 
  # (perhaps due to the behavior of flog.namespace for nested function call, 
  #  logger name becomes "base" instead of "futile.logger" 
  #  when no name is given.  this test is currently disabled)
  #out <- flog.info("log message")
  #out <- sub('[[:space:]]+$', '', out)  # remove line break at end
  #(out == '<ROOT> log message')

  # with logger name
  out <- get_log_output(flog.info("log message", name='mylogger'))
  (out == '<mylogger> log message\n')
})

assert("Custom layout dereferences level field", {
  flog.threshold(INFO)
  flog.layout(layout.format('xxx[~l]xxx'))
  raw <- get_log_output(flog.info("log message"))

  ('xxx[INFO]xxx\n' == raw)
  (length(grep('log message', raw)) == 0)
})

flog.layout(default.layout)
assert("Raw null value is printed", {
  raw <- get_log_output(flog.info('xxx[%s]xxx', NULL))
  (length(grep('xxx[NULL]xxx', raw, fixed=TRUE)) == 1)
})

assert("Single null value is printed", {
  opt <- list()
  raw <- get_log_output(flog.info('xxx[%s]xxx', opt$noexist))
  (length(grep('xxx[NULL]xxx', raw, fixed=TRUE)) == 1)
})

assert("Null is printed amongst variables", {
  opt <- list()
  raw <- get_log_output(flog.info('aaa[%s]aaa xxx[%s]xxx', 3, opt$noexist))
  (length(grep('aaa[3]aaa', raw, fixed=TRUE)) == 1)
  (length(grep('xxx[NULL]xxx', raw, fixed=TRUE)) == 1)
})

assert("no extra arguments are passed", {
  (grepl('foobar\n$', get_log_output(flog.info('foobar'))))
  (grepl('foobar %s\n$', get_log_output(flog.info('foobar %s'))))
  (grepl('10%\n$', get_log_output(flog.info('10%'))))
})

assert("some extra arguments are passed", {
  (grepl('foobar\n$', get_log_output(flog.info('foobar', pi))))
  (grepl(
    'foobar foo\n$',
    get_log_output(flog.info('foobar %s', 'foo'))))
  (grepl('100\n$', get_log_output(flog.info('10%d', 0))))
  (
    grepl('foo and bar equals to foobar\n',
          get_log_output(
            flog.info('%s and %s equals to %s', 'foo', 'bar', 'foobar'))))
})

assert("Function name detection inside nested functions", {
    flog.layout(layout.format("[~f] ~m"))
    a <- function() { flog.info("inside A") }
    b <- function() { a() }
    d <- function() { b() }
    e <- function() { d() }
    ('[a] inside A\n' == get_log_output(e()))
})

drop_log_prefix <- function(msg) {
    sub('[A-Z]* \\[.*\\] ', '', msg)
}

flog.layout(layout.glue)
assert("glue features work", {
  (drop_log_prefix(get_log_output(flog.info('foobar'))) == 'foobar\n')
  (drop_log_prefix(get_log_output(flog.info('{a}{b}', a = 'foo', b = 'bar'))) ==
    'foobar\n')
  (drop_log_prefix(get_log_output(flog.info('foo{b}', b = 'bar'))) == 'foobar\n')

  b <- 'bar'
  (drop_log_prefix(get_log_output(flog.info('foo{b}'))) == 'foobar\n')
  rm(b)

  (drop_log_prefix(get_log_output(flog.info('foo', 'bar'))) == 'foobar\n')
})

## back to the default layout
invisible(flog.layout(default.layout))

#' Manage layouts within the 'futile.logger' sub-system
#' 
#' Provides functions for managing layouts. Typically 'flog.layout' is only
#' used when manually creating a logging configuration.
#' 
#' @section Usage:
#' # Get the layout function for the given logger\cr
#' flog.layout(name) \%::\% character : Function\cr
#' flog.layout(name='ROOT')
#' 
#' # Set the layout function for the given logger\cr
#' flog.layout(fn, name='ROOT')
#' 
#' # Decorate log messages with a standard format\cr
#' layout.simple(level, msg, ...)
#' 
#' # Decorate log messages with a standard format colored by log level\cr
#' layout.colored(level, msg, ...)
#'
#' # Decorate log messages with a standard format using glue instead of sprintf\cr
#' layout.glue(level, msg, ...)
#'
#' # Decorate log messages with a standard format and a pid\cr
#' layout.simple.parallel(level, msg, ...)
#'
#' # Generate log messages as JSON\cr
#' layout.json(level, msg, ...)
#'
#' # Decorate log messages using a custom format\cr
#' layout.format(format, datetime.fmt="%Y-%m-%d %H:%M:%S")
#'
#' # Show the value of a single variable
#' layout.tracearg(level, msg, ...)
#' 
#' # Generate log messages in a Graylog2 HTTP GELF accetable format
#' layout.graylog(common.fields)
#' 
#' @section Details:
#' Layouts are responsible for formatting messages so they are human-readable.
#' Similar to an appender, a layout is assigned to a logger by calling 
#' \code{flog.layout}. The \code{flog.layout} function is used internally
#' to get the registered layout function. It is kept visible so 
#' user-level introspection is possible.
#' 
#' \code{layout.simple} is a pre-defined layout function that 
#' prints messages in the following format:\cr
#'   LEVEL [timestamp] message
#'
#' This is the default layout for the ROOT logger.
#' 
#' \code{layout.format} allows you to specify the format string to use 
#' in printing a message. The following tokens are available.
#' \describe{
#' \item{~l}{Log level}
#' \item{~t}{Timestamp}
#' \item{~n}{Namespace}
#' \item{~f}{The calling function}
#' \item{~m}{The message}
#' \item{~p}{The process PID}
#' \item{~i}{Logger name}
#' }
#'
#' \code{layout.json} converts the message and any additional objects provided
#' to a JSON structure. E.g.:
#' 
#' flog.info("Hello, world", cat='asdf')
#'  
#' yields something like
#' 
#' \{"level":"INFO","timestamp":"2015-03-06 19:16:02 EST","message":"Hello, world","func":"(shell)","cat":["asdf"]\}
#' 
#' \code{layout.tracearg} is a special layout that takes a variable
#' and prints its name and contents.
#' 
#' \code{layout.graylog} is a special layout for use with the appender.graylog to
#' generate json acceptable to a Graylog2 HTTP GELF endpoint. Standard fields to
#' be included with every message can be included by setting the common.fields
#' to a list of properties. E.g.: 
#' 
#' flog.layout(layout.graylog(common.fields = list(host_ip = "10.10.11.23", 
#'                                                 env = "production")))
#' 
#' @name flog.layout
#' @aliases layout.simple layout.simple.parallel layout.format layout.tracearg layout.json layout.graylog layout.glue layout.colored
#' @param \dots Used internally by lambda.r
#' @author Brian Lee Yung Rowe
#' @seealso \code{\link{flog.logger}} \code{\link{flog.appender}}
#' @keywords data
#' @examples
#' # Set the layout for 'my.package'
#' flog.layout(layout.simple, name='my.package')
#'
#' # Update the ROOT logger to use a custom layout
#' layout <- layout.format('[~l] [~t] [~n.~f] ~m')
#' flog.layout(layout)
#' 
#' # Create a custom logger to trace variables
#' flog.layout(layout.tracearg, name='tracer')
#' x <- 5
#' flog.info(x, name='tracer')
NULL

# Get the layout for the given logger
flog.layout(name) %::% character : Function
flog.layout(name='ROOT') %as%
{
  logger <- flog.logger(name)
  logger$layout
}

# Set the layout
flog.layout(fn, name='ROOT') %as%
{
  flog.logger(name, layout=fn)
  invisible()
}

#' Provide basic parsing for layout string
#'
#' Return name of argument if arg is empty. Otherwise return the value.
#'
#' @param x The argument to prepare
prepare_arg <- function(x) {
  if (is.null(x) || length(x) == 0) return(deparse(x))
  x
}

# This file provides some standard formatters
# This prints out a string in the following format:
#   LEVEL [timestamp] message
layout.simple <- function(level, msg, id='', ...)
{
  the.time <- format(Sys.time(), "%Y-%m-%d %H:%M:%S")
  if (length(list(...)) > 0) {
    parsed <- lapply(list(...), prepare_arg)
    msg <- do.call(sprintf, c(msg, parsed))
  }
  sprintf("%s [%s] %s\n", names(level),the.time, msg)
}

layout.simple.parallel <- function(level, msg, id='', ...)
{
  the.time <- format(Sys.time(), "%Y-%m-%d %H:%M:%S")
  the.pid  <- Sys.getpid()
  if (length(list(...)) > 0) {
    parsed <- lapply(list(...), prepare_arg)
    msg <- do.call(sprintf, c(msg, parsed))
  }
  sprintf("%s [%s %s] %s\n", names(level), the.time, the.pid, msg)
}

# Get name of a parent function in call stack
# @param .where: where in the call stack. -1 means parent of the caller.
.get.parent.func.name <- function(.where) {
  the.function <- tryCatch(deparse(sys.call(.where - 1)[[1]]), 
        error=function(e) "(shell)")
  the.function <- ifelse(
    length(grep('flog\\.',the.function)) == 0, the.function, '(shell)')

  the.function
}

# Generates a list object, then converts it to JSON and outputs it
layout.json <- function(level, msg, id='', ...) {
  if (!requireNamespace("jsonlite", quietly=TRUE))
    stop("layout.json requires jsonlite. Please install it.", call.=FALSE)
  
  the.function <- .get.parent.func.name(-3) # get name of the function 
                                            # 3 deep in the call stack
  
  output_list <- list(
    level=jsonlite::unbox(names(level)),
    timestamp=jsonlite::unbox(format(Sys.time(), "%Y-%m-%d %H:%M:%S %z")),
    message=jsonlite::unbox(msg),
    func=jsonlite::unbox(the.function),
    additional=...
  )
  paste0(jsonlite::toJSON(output_list, simplifyVector=TRUE), '\n')
}

# This parses and prints a user-defined format string. Available tokens are
# ~l - Log level
# ~t - Timestamp
# ~n - Namespace
# ~f - Calling function
# ~m - Message
# ~p - PID
#
# layout <- layout.format('[~l] [~t] [~n.~f] ~m')
# flog.layout(layout)
layout.format <- function(format, datetime.fmt="%Y-%m-%d %H:%M:%S")
{
  .where = -3 # get name of the function 3 deep in the call stack
              # that is, the function that has called flog.*
  function(level, msg, id='', ...) {
    if (! is.null(substitute(...))) msg <- sprintf(msg, ...)
    the.level <- names(level)
    the.time <- format(Sys.time(), datetime.fmt)
    the.namespace <- flog.namespace(.where)
    the.namespace <- ifelse(the.namespace == 'futile.logger', 'ROOT', the.namespace)
    the.function <- .get.parent.func.name(.where)
    the.pid <- Sys.getpid()
    the.id <- ifelse(id %in% c('', 'futile.logger'), 'ROOT', id) 
    #pattern <- c('~l','~t','~n','~f','~m')
    #replace <- c(the.level, the.time, the.namespace, the.function, msg)
    message <- gsub('~l',the.level, format, fixed=TRUE)
    message <- gsub('~t',the.time, message, fixed=TRUE)
    message <- gsub('~n',the.namespace, message, fixed=TRUE)
    message <- gsub('~f',the.function, message, fixed=TRUE)
    message <- gsub('~m',msg, message, fixed=TRUE)
    message <- gsub('~p',the.pid, message, fixed=TRUE)
    message <- gsub('~i',the.id, message, fixed=TRUE)
    sprintf("%s\n", message)
  }
}

layout.tracearg <- function(level, msg, id='', ...)
{
  the.time <- format(Sys.time(), "%Y-%m-%d %H:%M:%S")
  if (is.character(msg)) {
    if (! is.null(substitute(...))) msg <- sprintf(msg, ...)
  } else {
    external.call <- sys.call(-2)
    external.fn <- eval(external.call[[1]])
    matched.call <- match.call(external.fn, external.call)
    matched.call <- matched.call[-1]
    matched.call.names <- names(matched.call)

    ## We are interested only in the msg and ... parameters,
    ## i.e. in msg and all parameters not explicitly declared
    ## with the function
    is.output.param <- matched.call.names == "msg" |
      !(matched.call.names %in% c(setdiff(names(formals(external.fn)), "...")))

    label <- lapply(matched.call[is.output.param], deparse)
    msg <- sprintf("%s: %s", label, c(msg, list(...)))
  }
  sprintf("%s [%s] %s\n", names(level),the.time, msg)
}


# This creates a json string that will work with the appender.graylog
layout.graylog <- function(common.fields, datetime.fmt="%Y-%m-%d %H:%M:%S")
{
  .where = -3 # get name of the function 3 deep in the call stack
  # that is, the function that has called flog.*
  
  missing.common.fields <- missing(common.fields)
  
  function(level, msg, id='', ...) {
    
    if (! is.null(substitute(...))) msg <- sprintf(msg, ...)
    
    the.namespace <- flog.namespace(.where)
    
    output_list <- list(
      flogger_level = names(level),
      time = format(Sys.time(), datetime.fmt), 
      namespace = ifelse(the.namespace == 'futile.logger', 'ROOT', the.namespace),
      func = .get.parent.func.name(.where), 
      pid = Sys.getpid(),
      message = msg
    )
    
    if (!missing.common.fields)
      output_list <- c(output_list, common.fields)
    
    jsonlite::toJSON(output_list, auto_unbox = TRUE)
    
  }
}  

                           
layout.colored <- function(level, msg, id='', ...)
{

  if (!requireNamespace("crayon", quietly = TRUE)) {
    stop("Colored logging requires the 'crayon' package to be installed.")
  }

  the.time <- format(Sys.time(), "[%Y-%m-%d %H:%M:%S]")

  if (length(list(...)) > 0) {
    parsed <- lapply(list(...), function(x) if(is.null(x)) 'NULL' else x )
    msg <- do.call(sprintf, c(msg, parsed))
  }

  color <- switch(
    names(level),
    'FATAL' = function(x) crayon::bgRed(crayon::black(x)),
    'ERROR' = crayon::red,
    'WARN'  = crayon::yellow,
    'INFO'  = crayon::blue,
    'DEBUG' = crayon::silver,
    'TRACE' = crayon::blurred,
    crayon::white
    )

  color(paste(crayon::bold(names(level)), the.time, msg, crayon::reset('\n')))
}

layout.glue <- function(level, msg, id='', ...)
{
  if (!requireNamespace("glue", quietly=TRUE))
    stop("layout.glue requires glue. Please install it.", call.=FALSE)
  msg <- do.call(glue::glue, c(msg, list(...)), envir = parent.frame(3))
  layout.simple(level, msg)
}

assert("Default settings", {
  flog.threshold(INFO)
  raw <- get_log_output(flog.info("log message"))
  #cat("\n[test.default] Raw:",raw,"\n")
  (length(grep('INFO', raw)) > 0)
  (length(grep('log message', raw)) > 0)
})

assert("Change root threshold", {
  flog.threshold(ERROR)
  raw <- get_log_output(flog.info("log message"))
  #cat("\n[test.change_threshold] Raw:",raw,"\n")
  (length(raw) == 0)
})


assert("Capture works as expected", {
  flog.threshold(INFO)
  raw <- get_log_output(flog.info("log message", head(cars), capture = TRUE))
  (length(raw) == 1)
  (grepl('^INFO',raw))
  (grepl('dist',raw))
  })

assert("Get threshold names", {
  flog.threshold(ERROR)
  (flog.threshold() == "ERROR")  
  flog.threshold(DEBUG, name='my.package')
  (flog.threshold(name='my.package') == "DEBUG") 
})


assert("Create new logger", {
  flog.threshold(ERROR)
  flog.threshold(DEBUG, name='my.package')
  raw.root <- get_log_output(flog.info("log message"))
  raw.mine <- get_log_output(flog.info("log message", name='my.package'))
  (length(raw.root) == 0)
  (length(grep('INFO', raw.mine)) > 0)
  (length(grep('log message', raw.mine)) > 0)
})

assert("Hierarchy is honored", {
  flog.threshold(ERROR)
  flog.threshold(TRACE, name='my')
  flog.threshold(DEBUG, name='my.package')
  raw.root <- get_log_output(flog.info("log message"))
  raw.l1 <- get_log_output(flog.trace("log message", name='my'))
  raw.l2 <- get_log_output(flog.trace("log message", name='my.package'))
  (length(raw.root) == 0)
  (length(grep('TRACE', raw.l1)) > 0)
  (length(grep('log message', raw.l1)) > 0)
  (length(raw.l2) == 0)
})

assert("Hierarchy inheritance", {
  flog.remove('my.package')
  flog.remove('my')
  flog.threshold(ERROR)
  flog.threshold(TRACE, name='my')
  raw.root <- get_log_output(flog.info("log message"))
  raw.l1 <- get_log_output(flog.trace("log message", name='my'))
  raw.l2 <- get_log_output(flog.trace("log message", name='my.package'))
  (length(raw.root) == 0)
  (length(grep('TRACE', raw.l1)) > 0)
  (length(grep('log message', raw.l1)) > 0)
  (length(grep('TRACE', raw.l2)) > 0)
  (length(grep('log message', raw.l2)) > 0)
})


# Can't test this since assert calls suppressMessages
assert("ftry captures warnings", {
  raw <- get_log_output(ftry(log(-1)))
  cat("raw =",raw,'\n')
  (length(grep('WARN', raw)) > 0)
  (length(grep('simpleWarning', raw)) > 0)
})

assert("carp returns output", {
  on.exit(flog.carp(FALSE))

  flog.carp(TRUE)
  (flog.carp())
  flog.threshold(WARN)
  raw <- flog.debug("foo")
  flog.carp(FALSE)
  (length(grep('DEBUG', raw)) > 0)
})

assert("logger can be provided explicitly", {
  flog.threshold(DEBUG, name='my.package')
  my_logger <- flog.logger('my.package')
  with_logger <- get_log_output(flog.info("log message", logger=my_logger))
  (length(grep('INFO', with_logger)) > 0)
  (length(grep('log message', with_logger)) > 0)
})
assert("logger provided explicitly is much faster if nothing has to be logged", {
  flog.threshold(INFO, name='my.package')
  my_logger <- flog.logger('my.package')
  fun_wn <- function(i) {
    flog.debug("step %d", i, name='my.package')
    i
  }
  fun_wl <- function(i) {
    flog.debug("step %d", i, logger=my_logger)
    i
  }
  tw <- system.time(for (i in 1:10000) fun_wn(i))["elapsed"]
  tl <- system.time(for (i in 1:10000) fun_wl(i))["elapsed"]
  (tw > tl*10)
})

assert("trace threshold is set via string", {
    flog.threshold("trace")
    (flog.threshold() == "TRACE")
    (flog.logger()$threshold == 9)
    flog.threshold("TRACE")
    (flog.threshold() == "TRACE")
})

assert("debug threshold is set via string", {
    flog.threshold("debug")
    (flog.threshold() == "DEBUG")
    (flog.logger()$threshold == 8)
    flog.threshold("DEBUG")
    (flog.threshold() == "DEBUG")
})

assert("info threshold is set via string", {
    flog.threshold("info")
    (flog.threshold() == "INFO")
    (flog.logger()$threshold == 6)
    flog.threshold("INFO")
    (flog.threshold() == "INFO")
})

assert("warn threshold is set via string", {
    flog.threshold("warn")
    (flog.threshold() == "WARN")
    (flog.logger()$threshold == 4)
    flog.threshold("WARN")
    (flog.threshold() == "WARN")
})

assert("error threshold is set via string", {
    flog.threshold("error")
    (flog.threshold() == "ERROR")
    (flog.logger()$threshold == 2)
    flog.threshold("ERROR")
    (flog.threshold() == "ERROR")
})

assert("fatal threshold is set via string", {
    flog.threshold("fatal")
    (flog.threshold() == "FATAL")
    (flog.logger()$threshold == 1)
    flog.threshold("FATAL")
    (flog.threshold() == "FATAL")
})

#' Print formatted messages
#' 
#' A replacement for \code{cat} that has built-in sprintf formatting
#' 
#' Like \code{cat} but you can use format strings.
#' 
#' @param format A format string passed to sprintf
#' @param use.newline Whether to append a new line at the end
#' @param \dots Arguments to pass to sprintf for dereferencing
#' @return A formatted string printed to the console
#' @author Brian Lee Yung Rowe
#' @keywords data
#' @examples
#' 
#'   apply(array(2:5),1, function(x) scat('This has happened %s times', x) )
#' 
scat <- function(format, ..., use.newline=TRUE)
{
  if (use.newline) newline = '\n'
  else newline = ''

  cat(paste(sprintf(format, ...), newline, sep=''))
}

#' Manage loggers
#' 
#' Provides functions for writing log messages and managing loggers. Typically
#' only the flog.[trace|debug|info|warn|error|fatal] functions need to be used
#' in conjunction with flog.threshold to interactively change the log level.
#' 
#' @section Usage:
#' # Conditionally print a log statement at TRACE log level\cr
#' flog.trace(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)
#'
#' # Conditionally print a log statement at DEBUG log level\cr
#' flog.debug(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)
#'
#' # Conditionally print a log statement at INFO log level\cr
#' flog.info(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)
#'
#' # Conditionally print a log statement at WARN log level\cr
#' flog.warn(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)
#'
#' # Conditionally print a log statement at ERROR log level\cr
#' flog.error(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)
#'
#' # Print a log statement at FATAL log level\cr
#' flog.fatal(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)
#'
#' # Execute an expression and capture any warnings or errors
#' ftry(expr, error=stop, silent=FALSE, finally=NULL, details='')
#'
#' @section Additional Usage:
#' These functions generally do not need to be called by an end user.
#'
#' # Get the ROOT logger\cr
#' flog.logger()
#' 
#' # Get the logger with the specified name\cr
#' flog.logger(name)
#'
#' # Set options for the given logger\cr
#' flog.logger(name, threshold=NULL, appender=NULL, layout=NULL, carp=NULL)
#' 
#' @section Details:
#' These functions represent the high level interface to futile.logger.
#' 
#' The primary use case for futile.logger is to write out log messages. There
#' are log writers associated with all the predefined log levels: TRACE, DEBUG,
#' INFO, WARN, ERROR, FATAL. Log messages will only be written if the log level
#' is equal to or more urgent than the current threshold. By default the ROOT
#' logger is set to INFO.
#' 
#' > flog.debug("This won't print") \cr
#' > flog.info("But this \%s", 'will') \cr
#' > flog.warn("As will \%s", 'this')
#' 
#' Typically, the built in log level constants are used in the call, which
#' conform to the log4j levels (from least severe to most severe): TRACE,
#' DEBUG, INFO, WARN, ERROR, FATAL. It is not a strict requirement to use these
#' constants (any numeric value will work), though most users should find this
#' level of granularity sufficient.
#' 
#' Loggers are hierarchical in the sense that any requested logger that is
#' undefined will fall back to its most immediate defined parent logger. The
#' absolute parent is ROOT, which is guaranteed to be defined for the system
#' and cannot be deleted. This means that you can specify a new logger
#' directly.
#' 
#' > flog.info("This will fall back to 'my', then 'ROOT'", name='my.logger')
#' 
#' You can also change the threshold or any other setting associated with a
#' logger. This will create an explicit logger where any unspecified options
#' are copied from the parent logger.
#' 
#' > flog.appender(appender.file("foo.log"), name='my') \cr
#' > flog.threshold(ERROR, name='my.logger') \cr
#' > flog.info("This won't print", name='my.logger') \cr
#' > flog.error("This %s print to a file", 'will', name='my.logger') \cr
#' 
#' If you have a function which gets called many times, it is a good strategy 
#' to pass the logger directly instead of its name.
#' 
#' Instead of this:
#' > simulation_fun <- function(i) {
#' >   flog.trace("We are in loop %d", i, name='my.logger')
#' >   i
#' > }
#' 
#' ... you can do this::
#' > my_logger <- flog.logger("my.logger")
#' > simulation_fun2 <- function(i) {
#' >   flog.trace("We are in loop %d", i, logger=my_logger)
#' >   i
#' > }
#' 
#' > system.time(for (i in 1:1000) simulation_fun(i))
#' > system.time(for (i in 1:1000) simulation_fun2(i))
#' 
#' If you define a logger that you later want to remove, use flog.remove.
#' 
#' The option 'capture' allows you to print out more complicated data
#' structures without a lot of ceremony. This variant doesn't accept format
#' strings and instead appends the value to the next line of output. Consider 
#'
#' > m <- matrix(rnorm(12), nrow=3) \cr
#' > flog.info("Matrix:",m, capture=TRUE)
#'
#' which preserves the formatting, whereas using capture=FALSE will have 
#' a cluttered output due to recycling.
#' 
#' @name flog.logger
#' @aliases flog.trace flog.debug flog.info flog.warn flog.error flog.fatal
#' @param msg The message to log
#' @param name The logger name to use
#' @param capture Capture print output of variables instead of interpolate
#' @param logger The logger to use. If \code{NULL} (the default), it is 
#' looked up based on \code{name}. Provide \code{logger} explicitely if 
#' the speed of the evaluation of log level is of concern (e.g., a 
#' \code{flog.trace} call in your function which has to be run many times).
#' @param \dots Optional arguments to populate the format string
#' @param expr An expression to evaluate
#' @param finally An optional expression to evaluate at the end
#' @author Brian Lee Yung Rowe
#' @seealso \code{\link{flog.threshold}} \code{\link{flog.remove}}
#' \code{\link{flog.carp}} \code{\link{flog.appender}} \code{\link{flog.layout}}
#' @keywords data
#' @examples
#' 
#' flog.threshold(DEBUG)
#' flog.debug("This debug message will print")
#' 
#' flog.threshold(WARN)
#' flog.debug("This one won't")
#' 
#' m <- matrix(rnorm(12), nrow=3)
#' flog.info("Matrix:",m, capture=TRUE)
#' 
#' ftry(log(-1))
#' 
#' \dontrun{
#' s <- c('FCX','AAPL','JPM','AMZN')
#' p <- TawnyPortfolio(s)
#'
#' flog.threshold(TRACE,'tawny')
#' ws <- optimizePortfolio(p, RandomMatrixDenoiser())
#' z <- getIndexComposition()
#'
#' flog.threshold(WARN,'tawny')
#' ws <- optimizePortfolio(p, RandomMatrixDenoiser())
#' z <- getIndexComposition()
#' }
#'
#' \dontrun{
#' flog.appender(appender.modulo(1000), name='counter')
#' lapply(1:10000, function(i) flog.info("value is %s",i, name='counter'))
#' }
NULL

.log_level <- function(msg, ..., level, name, capture, logger = NULL)
{
  if (is.null(logger)) logger <- flog.logger(name)
  if (level > logger$threshold && (is.null(logger$carp) || !logger$carp)) {
    return(invisible())
  }

  appender <- logger$appender
  layout <- logger$layout
  if (capture) {
    values <- paste(capture.output(print(...)), collapse='\n')
    message <- c(layout(level, msg, name), "\n", values, "\n")
  } else {
    message <- layout(level, msg, name, ...)
  }
  if (level <= logger$threshold) appender(message)
  invisible(message)
}

# Get the namespace that a function resides in. If no namespace exists, then
# return NULL.
# @param .where: where in the call stack should be check. 
#             0: current function (always
#            -1: parents of this function.
#            -3: when used within flog.*, 
#                it refers to the original caller of flog.*
#            -4: when used from flogger.name within a .log_level
#
# <environment: namespace:lambda.r>
flog.namespace <- function(.where=-4)
{
  sf <- sys.function(.where - 1)
  s <- format(topenv(environment(sf)))
  if (length(grep('lambda.r',s)) > 0)
    s <- attr(sys.function(-5), 'topenv')

  if (length(grep('namespace', s)) < 1) return('ROOT')

  ns <- sub('.*namespace:([^>]+)>.*','\\1', s)
  ifelse(is.null(ns), 'ROOT', ns)
}

flog.trace <- function(msg, ..., name=flog.namespace(), capture=FALSE, logger=NULL) {
  .log_level(msg, ..., level=TRACE,name=name, capture=capture, logger=logger)
}

flog.debug <- function(msg, ..., name=flog.namespace(), capture=FALSE, logger=NULL) {
  .log_level(msg, ..., level=DEBUG,name=name, capture=capture, logger=logger)
}

flog.info <- function(msg, ..., name=flog.namespace(), capture=FALSE, logger=NULL) {
  .log_level(msg, ..., level=INFO,name=name, capture=capture, logger=logger)
}

flog.warn <- function(msg, ..., name=flog.namespace(), capture=FALSE, logger=NULL) {
  .log_level(msg, ..., level=WARN,name=name, capture=capture, logger=logger)
}

flog.error <- function(msg, ..., name=flog.namespace(), capture=FALSE, logger=NULL) {
  .log_level(msg, ..., level=ERROR,name=name, capture=capture, logger=logger)
}

flog.fatal <- function(msg, ..., name=flog.namespace(), capture=FALSE, logger=NULL) {
  .log_level(msg, ..., level=FATAL,name=name, capture=capture, logger=logger)
}

#' Wrap a try block in futile.logger
#'
#' This function integrates futile.logger with the error and warning system
#' so problems can be caught both in the standard R warning system, while
#' also being emitted via futile.logger.
#'
#' @name ftry
#' @param expr The expression to evaluate in a try block
#' @param error An error handler
#' @param finally Pass-through to tryCatch finally
#' @param silent Boolean - should errors be rethrown? The same as the silent option on `try`.
#' If a custom error handler is being used that takes control over this option. Note you should
#' test the return value if you are dependent on it.
#' @param details An extra string to print when there's a warning message
#' @author Brian Lee Yung Rowe
#' @keywords data
#' @examples
#' \dontrun{
#' ftry(log("a")) # Logs the warning (but the warning still bubbles)
#'
#' x <- 'a'
#' y <- 2 # Some ID associated with x value
#' ftry(log("a"), details=sprintf("y = %s",y))
#'
#' ftry(log(-1)) # Logs the error and rethrows it
#' }
#' ftry(log(-1),silent=TRUE) # logs the error and silently continues
ftry <- function(expr, error=stop, finally=NULL, silent=FALSE, details='') {
  w.handler <- function(e) {
    flog.warn(paste("(",details,") %s", sep=''), e)
  }
  e.handler <- function(e) {
    flog.error(paste("(",details,") %s", sep=''), e)
    if (!silent | !isTRUE(all.equal(error, stop))) { error(e) }
  }
  tryCatch(
    withCallingHandlers(
      expr,
      warning = w.handler
    ),
    error = e.handler,
    finally
  )
}

# By default, use the package namespace or use the 'ROOT' logger.
flog.logger() %as%
{
  flog.logger(flog.namespace())
}

flog.logger(name) %as%
{
  if (nchar(name) < 1) name <- 'ROOT'
  #cat(sprintf("Searching for logger %s\n", name))

  key <- paste("logger", name, sep='.')
  # TODO: Search hierarchy
  os <- logger.options(key)
  if (! is.null(os)) return(os)
  if (name == 'ROOT') {
    logger <- list(name=name,
      threshold=INFO,
      appender=appender.console(),
      layout=layout.simple)
    logger.options(update=list(key, logger))
    return(logger)
  }

  parts <- strsplit(name, '.', fixed=TRUE)[[1]]
  parent <- paste(parts[1:length(parts)-1], collapse='.')
  flog.logger(parent)
}

flog.logger(name, threshold=NULL, appender=NULL, layout=NULL, carp=NULL) %as%
{
  logger <- flog.logger(name)
  if (!is.null(threshold)) logger$threshold <- threshold
  if (!is.null(appender)) logger$appender <- appender
  if (!is.null(layout)) logger$layout <- layout
  if (!is.null(carp)) logger$carp <- carp

  key <- paste("logger", name, sep='.')
  logger.options(update=list(key, logger))
  invisible()
}


#' Remove a logger
#' 
#' In the event that you no longer wish to have a logger registered,
#' use this function to remove it. Then any references to this
#' logger will inherit the next available logger in the hierarchy.
#'
#' @section Usage:
#' # Remove a logger\cr
#' flog.remove(name)
#' 
#' @name flog.remove
#' @param name The logger name to use
#' @author Brian Lee Yung Rowe
#' @keywords data
#' @examples
#' flog.threshold(ERROR, name='my.logger')
#' flog.info("Won't print", name='my.logger')
#' flog.remove('my.logger')
#' flog.info("Will print", name='my.logger')
flog.remove('ROOT') %as% { invisible() }
flog.remove(name) %as%
{
  key <- paste("logger", name, sep='.')
  logger.options(update=list(key, NULL))
  invisible()
}

#' Get and set the threshold for a logger
#'
#' The threshold affects the visibility of a given logger. When a log
#' statement is called, e.g. \code{flog.debug('foo')}, futile.logger
#' compares the threshold of the logger with the level implied in the
#' log command (in this case DEBUG). If the log level is at or higher
#' in priority than the logger threshold, a message will print.
#' Otherwise the command will silently return.
#'
#' @section Usage:
#' # Get the threshold for the given logger\cr
#' flog.threshold(name) \%::\% character : character \cr
#' flog.threshold(name=ROOT)
#'
#' # Set the threshold for the given logger\cr
#' flog.threshold(threshold, name=ROOT)
#' 
#' @name flog.threshold
#' @param threshold integer The new threshold for the given logger
#' @param name character The name of the logger
#' @author Brian Lee Yung Rowe
#' @keywords data
#' @examples
#' flog.threshold(ERROR)
#' flog.info("Won't print")
#' flog.threshold(INFO)
#' flog.info("Will print")
# Set the threshold
flog.threshold('TRACE', name='ROOT') %as% flog.threshold(TRACE, name)
flog.threshold('trace', name='ROOT') %as% flog.threshold(TRACE, name)
flog.threshold('DEBUG', name='ROOT') %as% flog.threshold(DEBUG, name)
flog.threshold('debug', name='ROOT') %as% flog.threshold(DEBUG, name)
flog.threshold('INFO', name='ROOT') %as% flog.threshold(INFO, name)
flog.threshold('info', name='ROOT') %as% flog.threshold(INFO, name)
flog.threshold('WARN', name='ROOT') %as% flog.threshold(WARN, name)
flog.threshold('warn', name='ROOT') %as% flog.threshold(WARN, name)
flog.threshold('ERROR', name='ROOT') %as% flog.threshold(ERROR, name)
flog.threshold('error', name='ROOT') %as% flog.threshold(ERROR, name)
flog.threshold('FATAL', name='ROOT') %as% flog.threshold(FATAL, name)
flog.threshold('fatal', name='ROOT') %as% flog.threshold(FATAL, name)


flog.threshold(threshold, name) %::% numeric : character : .
flog.threshold(threshold, name='ROOT') %as%
{
  flog.logger(name, threshold=threshold)
  invisible()
}

# Get the threshold
flog.threshold(name) %::% character : character
flog.threshold(name='ROOT') %as%
{
  logger <- flog.logger(name)
  names(logger$threshold)
}


#' Always return the log message
#'
#' Indicate whether the logger will always return the log message
#' despite the threshold.
#' 
#' This is a special option to allow the return value of the flog.*
#' logging functions to return the generated log message even if
#' the log level does not exceed the threshold. Note that this 
#' minorly impacts performance when enabled. This functionality
#' is separate from the appender, which is still bound to the 
#' value of the logger threshold.
#'
#' @section Usage:
#' # Indicate whether the given logger should carp\cr
#' flog.carp(name=ROOT)
#'
#' # Set whether the given logger should carp\cr
#' flog.carp(carp, name=ROOT)
#'
#' @name flog.carp
#' @param carp logical Whether to carp output or not
#' @param name character The name of the logger
#' @author Brian Lee Yung Rowe
#' @keywords data
#' @examples
#' flog.carp(TRUE)
#' x <- flog.debug("Returns this message but won't print")
#' flog.carp(FALSE)
#' y <- flog.debug("Returns nothing and prints nothing")
flog.carp(name) %::% character : logical
flog.carp(name='ROOT') %as%
{
  logger <- flog.logger(name)
  if (is.null(logger$carp)) FALSE
  else logger$carp
}

# Set whether to carp
flog.carp(carp, name='ROOT') %as%
{
  flog.logger(name, carp=carp)
  invisible()
}

FATAL <- 1L
names(FATAL) <- "FATAL"
ERROR <- 2L
names(ERROR) <- "ERROR"
WARN <- 4L
names(WARN) <- "WARN"
INFO <- 6L
names(INFO) <- "INFO"
DEBUG <- 8L
names(DEBUG) <- "DEBUG"
TRACE <- 9L
names(TRACE) <- "TRACE"

#' Manage appenders for loggers
#' 
#' Provides functions for adding and removing appenders.
#' 
#' @section Usage:
#' # Get the appender for the given logger\cr
#' flog.appender(name) \%::\% character : Function\cr
#' flog.appender(name='ROOT')
#'
#' # Set the appender for the given logger\cr
#' flog.appender(fn, name='ROOT')
#'
#' # Print log messages to the console\cr
#' appender.console()
#' 
#' # Write log messages to a file\cr
#' appender.file(file)
#' 
#' # Write log messages to a dynamically-named file\cr
#' appender.file2(format)
#' 
#' # Write log messages to console and a file\cr
#' appender.tee(file)
#' 
#' # Write log messages to a Graylog2 HTTP GELF endpoint\cr
#' appender.graylog(server, port)
#' 
#' # Write log message to syslog. Arguments are passed on to \code{\link[rsyslog]{open_syslog}}.\cr
#' appender.syslog(identifier, ...)
#'
#' # Special meta appender that prints only when the internal counter mod n = 0\cr
#' appender.modulo(n, appender=appender.console())
#'
#' @section Details:
#' Appenders do the actual work of writing log messages to some target.
#' To use an appender in a logger, you must register it to a given logger.
#' Use \code{flog.appender} to both access and set appenders.
#' 
#' The ROOT logger by default uses \code{appender.console}.
#' 
#' \code{appender.console} is a function that writes to the console.
#' No additional arguments are necessary when registering the appender 
#' via flog.appender.
#' 
#' \code{appender.file} writes to a file, so you must pass an additional file
#' argument to the function. To change the file name, just call
#' \code{flog.appender(appender.file(file))} again with a new file name.
#'
#' \code{appender.file2} is similar, but the filename is dynamically
#' determined at runtime. It may include most of the same tokens as
#' \code{layout.format} (all except \code{"~m"}, the message
#' itself). This allows, for instance, having separate logfiles for
#' each log level.
#' 
#' To use your own appender create a function that takes a single argument,
#' which represents the log message. You need to pass a function reference to
#' \code{flog.appender}.
#' 
#' \code{appender.tee} writes to both the console and file.
#' 
#' \code{appender.graylog} writes to a Graylog2 HTTP GELF endpoint.
#'
#' \code{appender.syslog} writes to the POSIX system logger.
#'
#' \code{appender.modulo} is a meta appender. It calls \code{appender} every \code{n} times.
#'
#' @section Value:
#' When getting the appender, \code{flog.appender} returns the appender
#' function.  When setting an appender, \code{flog.appender} has no 
#' return value.
#'
#' @name flog.appender
#' @aliases appender.console appender.file appender.file2 appender.tee appender.modulo appender.graylog appender.syslog
#' @param \dots Used internally by lambda.r
#' @author Brian Lee Yung Rowe
#' @seealso \code{\link{flog.logger}} \code{\link{flog.layout}}
#' @keywords data
#' @examples
#' \dontrun{
#' flog.appender(appender.console(), name='my.logger')
#'
#' # Set an appender to the logger named 'my.package'. Any log operations from
#' # this package will now use this appender.
#' flog.appender(appender.file('my.package.out'), 'my.package')
#'
#' # Set an appender to a file named using the message level and calling function.
#' # Also tee the messages to the console.
#' flog.appender(appender.file2('~l-~f.log', console = TRUE))
#' }

# Get appenders associated with the given logger
flog.appender(name) %::% character : Function
flog.appender(name='ROOT') %as%
{
  logger <- flog.logger(name)
  logger$appender
}

# Set the appender for the given logger
flog.appender(fn, name='ROOT') %as%
{
  flog.logger(name, appender=fn)
  invisible()
}

# Some default handlers for use in futile.logger. All handlers need to conform
# to the below signature: function(line)
appender.console <- function()
{
  function(line) .write_to_console(line)
}

# Write to a file.
appender.file <- function(file)
{
  function(line) cat(line, file=file, append=TRUE, sep='')
}

# Write to a file and to console 
appender.tee <- function(file){ 
  function(line) {
    .write_to_console(line)
    cat(line, file=file, append=TRUE, sep='')
  }
}

# Write to a dynamically-named file (and optionally the console), with inheritance
appender.file2 <- function(format, console=FALSE, inherit=TRUE,
                           datetime.fmt="%Y%m%dT%H%M%S") {
  .nswhere <- -3 # get name of the function 2 deep in the call stack
                 # that is, the function that has called flog.*
  .funcwhere <- -3 # ditto for the function name
  .levelwhere <- -1 # ditto for the current "level"
  function(line) {
    if (console) .write_to_console(line)

    err <- function(e) {
      stop('Illegal function call, must call from flog.trace, flog.debug, flog.info, flog.warn, flog.error, flog.fatal, etc.')
    }
    the.level <- tryCatch(get("level",
      envir=sys.frame(.levelwhere)), error=err)
    the.threshold <- tryCatch(get('logger',
      envir=sys.frame(.levelwhere)), error=err)$threshold

    if (inherit) {
      LEVELS <- c(FATAL, ERROR, WARN, INFO, DEBUG, TRACE)
      levels <- names(LEVELS[the.level <= LEVELS & LEVELS <= the.threshold])
    } else {
      levels <- names(the.level)
    }

    the.time <- format(Sys.time(), datetime.fmt)
    the.namespace <- flog.namespace(.nswhere)
    the.namespace <- ifelse(the.namespace == 'futile.logger', 'ROOT', the.namespace)
    the.function <- .get.parent.func.name(.funcwhere)
    the.pid <- Sys.getpid()
    filename <- gsub('~t', the.time, format, fixed=TRUE)
    filename <- gsub('~n', the.namespace, filename, fixed=TRUE)
    filename <- gsub('~f', the.function, filename, fixed=TRUE)
    filename <- gsub('~p', the.pid, filename, fixed=TRUE)
    if (length(grep('~l', filename)) > 0) {
      sapply(levels, function(level) {
        filename <- gsub('~l', level, filename, fixed=TRUE)
        cat(line, file=filename, append=TRUE, sep='')
      })
    } else {
      cat(line, file=filename, append=TRUE, sep='')
    }
    invisible()
  }
}


# Special meta appender that prints only when the internal counter mod n = 0
appender.modulo <- function(n, appender=appender.console()) {
  i <- 0
  function(line) {
    i <<- i + 1
    if (i %% n == 0) appender(sprintf("[%s] %s", i,line))
    invisible()
  }
}

# Write to a Graylog2 HTTP GELF Endpoint
appender.graylog <- function(server, port, debug = FALSE) {

  if (!requireNamespace("jsonlite", quietly=TRUE))
    stop("appender.graylog requires jsonlite. Please install it.", call. = FALSE)
  if (!requireNamespace("httr", quietly=TRUE))
    stop("appender.graylog requires httr. Please install it.", call. = FALSE)  
  
  function(line) {

    ret <- httr::POST(paste0("http://", server, ":", port, "/gelf"), 
                      body = list(short_message = line),
                      encode = 'json')
    
    if (debug) print(ret)
  }
}

# Append to the POSIX System Logger
#
# @param identifier A string identifying the application.
# @param ... Further arguments passed on to \code{\link[rsyslog]{open_syslog}}.
appender.syslog <- function(identifier, ...) {
  if (!requireNamespace("rsyslog", quietly = TRUE)) {
    stop("appender.syslog requires the 'rsyslog' package.", call. = FALSE)
  }
  rsyslog::open_syslog(identifier = identifier, ...)

  function(line) {
    level <- tryCatch(get("level", envir = sys.frame(-1)), error = INFO)
    # Translate between futile.logger levels and syslog priority levels.
    level <- switch(
      names(level), "TRACE" = "DEBUG", "DEBUG" = "DEBUG", "INFO" = "INFO",
      "WARN" = "WARNING", "ERROR" = "ERR", "FATAL" = "CRITICAL"
    )
    rsyslog::syslog(line, level = level)
  }
}

assert("debug level is logged", {
    flog.threshold(DEBUG)
    msg <- 'test debug'
    act <- get_log_output(flog.debug(msg))
    (grepl(msg, act))
})

assert("higher levels are logged", {
    flog.threshold(DEBUG)
    act.info <- get_log_output(flog.info('test info'))
    (grepl('test info', act.info))

    act.warn <- get_log_output(flog.warn('test warn'))
    (grepl('test warn', act.warn))

    act.error <- get_log_output(flog.error('test error'))
    (grepl('test error', act.error))

    act.fatal <- get_log_output(flog.fatal('test fatal'))
    (grepl('test fatal', act.fatal))
})

assert("lower levels are not logged", {
    flog.threshold(DEBUG)
    act <- get_log_output(flog.trace("testlog"))
    (length(act) < 1)
})

if (requireNamespace("jsonlite", quietly=TRUE)) {
flog.threshold(INFO)
flog.layout(layout.json)

assert("simple string", {
  raw <- get_log_output(flog.info("log message"))
  aslist <- jsonlite::fromJSON(raw)
  (aslist$level == "INFO")
  (aslist$message == "log message")

  ts <- strptime(aslist$timestamp, "%Y-%m-%d %H:%M:%S %z")
  ('POSIXt' %in% class(ts))
})

assert("additional objects", {
  raw <- get_log_output(
    flog.info("log message", pet="hamster", weight=12, stuff=c("a", "b")))
  aslist <- jsonlite::fromJSON(raw)
  (aslist$level == "INFO")
  (aslist$message == "log message")
  (aslist$pet == "hamster")
  (aslist$weight == 12)
  (aslist$stuff == c("a", "b"))
})


assert("NULL additional objects", {
  raw <- get_log_output(flog.info("log message", nullthing=NULL))
  aslist <- jsonlite::fromJSON(raw)
  (length(aslist$nullthing) == 0)
})

# knockdown
flog.layout(layout.simple)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logger.R
\name{flog.carp}
\alias{flog.carp}
\title{Always return the log message}
\arguments{
\item{carp}{logical Whether to carp output or not}

\item{name}{character The name of the logger}
}
\description{
Indicate whether the logger will always return the log message
despite the threshold.
}
\details{
This is a special option to allow the return value of the flog.*
logging functions to return the generated log message even if
the log level does not exceed the threshold. Note that this 
minorly impacts performance when enabled. This functionality
is separate from the appender, which is still bound to the 
value of the logger threshold.
}
\section{Usage}{

# Indicate whether the given logger should carp\cr
flog.carp(name=ROOT)

# Set whether the given logger should carp\cr
flog.carp(carp, name=ROOT)
}

\examples{
flog.carp(TRUE)
x <- flog.debug("Returns this message but won't print")
flog.carp(FALSE)
y <- flog.debug("Returns nothing and prints nothing")
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logger.R
\name{ftry}
\alias{ftry}
\title{Wrap a try block in futile.logger}
\usage{
ftry(expr, error = stop, finally = NULL, silent = FALSE, details = "")
}
\arguments{
\item{expr}{The expression to evaluate in a try block}

\item{error}{An error handler}

\item{finally}{Pass-through to tryCatch finally}

\item{silent}{Boolean - should errors be rethrown? The same as the silent option on `try`.
If a custom error handler is being used that takes control over this option. Note you should
test the return value if you are dependent on it.}

\item{details}{An extra string to print when there's a warning message}
}
\description{
This function integrates futile.logger with the error and warning system
so problems can be caught both in the standard R warning system, while
also being emitted via futile.logger.
}
\examples{
\dontrun{
ftry(log("a")) # Logs the warning (but the warning still bubbles)

x <- 'a'
y <- 2 # Some ID associated with x value
ftry(log("a"), details=sprintf("y = \%s",y))

ftry(log(-1)) # Logs the error and rethrows it
}
ftry(log(-1),silent=TRUE) # logs the error and silently continues
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/futile.logger-package.R
\docType{package}
\name{futile.logger-package}
\alias{futile.logger-package}
\alias{futile.logger}
\alias{flog.namespace}
\title{A Logging Utility for R}
\description{
This package implements a logging system inspired by log4j. The basic idea
of layouts, appenders, and loggers is faithful to log4j, while the
implementation and idiom is all R. This means that support for hierarchical
loggers, custom appenders, custom layouts is coupled with a simple and
intuitive functional syntax.
}
\details{
\tabular{ll}{
Package: \tab futile.logger\cr
Type: \tab Package\cr
Version: \tab 1.4.9\cr
Date: \tab 2025-12-22\cr
License: \tab LGPL-3\cr
LazyLoad: \tab yes\cr
}

The latest version of futile.logger introduces zero-configuration semantics
out of the box. This means that you can use the default configuration as is.
It is also easy to interactively change the configuration of the ROOT
logger, as well as create new loggers. Since loggers form a hierarchy based
on their name, the ROOT logger is the starting point of the hierarchy and
always exists. By default the ROOT logger is defined with a simple layout,
printing to the console, with an INFO threshold. This means that writing to
any logger with a threshold of INFO or higher will write to the console.

All of the logging functions take a format string so it is easy to add
arbitrary values to log messages.

> flog.info("This song is just \%s words \%s", 7, "long")

Thresholds range from most verbose to least verbose: TRACE, DEBUG, INFO,
WARN, ERROR, FATAL. You can easily change the threshold of the ROOT logger
by calling > flog.threshold(TRACE) which changes will print all log messages
from every package. To suppress most logging by default but turn on all
debugging for a logger 'my.logger', you would execute 

> flog.threshold(ERROR)\cr
> flog.threshold(TRACE, name='my.logger')

Any arbitrary logger can be defined simply by specifying it in any
futile.logger write operation (futile.threshold, futile.appender,
futile.layout). If the logger hasn't been defined, then it will be defined
dynamically. Any unspecified options will be copied from the parent logger.

When writing log messages, futile.logger will search the hierarchy based on
the logger name. In our example, if 'my.logger' hasn't been defined then
futile.logger will look for a logger named 'my' and finally the ROOT logger.

Functions calling futile.logger from a package are automatically assigned a
logger that has the name of the package. Suppose we have log messages in a
package called 'my.package'. Then any function that calls futile.logger from
within the package will automatically be assigned a default logger of
'my.package' instead of ROOT. This means that it is easy to change the log
setting of any package that uses futile.logger for logging by just updating
the logger for the given package. For instance suppose you want to output
log message for my.package to a file instead.

> flog.appender(appender.file('my.package.log'), name='my.package')

Now all log statements in the package my.package will be written to a file
instead of the console. All other log messages will continue to be written
to the console.

Appenders do the actual work of writing log messages to a writeable target,
whether that is a console, a file, a URL, database, etc. When creating an
appender, the implementation-specific options are passed to the appender at
instantiation. The package defines two appender generator functions:

\describe{
  \item{appender.file}{Write to a file}
  \item{appender.console}{Write to the console}
}

Each of these functions returns the actual appender function, so be sure to
actually call the function!

Layouts are responsible for formatting messages. This operation usually
consists of adding the log level, a timestamp, plus some pretty-printing to
make the log messages easy on the eyes. The package supplies several layouts:

\describe{
  \item{layout.simple}{Writes messages with a default format}
  \item{layout.simple.parallel}{Writes messages with a default format with PID}
  \item{layout.json}{Generates messages in a JSON format}
  \item{layout.format}{Define your own format}
  \item{layout.tracearg}{Print a variable name along with its value}
}
}
\examples{

flog.debug("This \%s print", "won't")
flog.warn("This \%s print", "will")
  
flog.info("This inherits from the ROOT logger", name='logger.a')
flog.threshold(DEBUG, name='logger.a')
flog.debug("logger.a has now been set to DEBUG", name='logger.a')
flog.debug("But the ROOT logger is still at INFO (so this won't print)")

\dontrun{
flog.appender(appender.file("other.log"), name='logger.b')
flog.info("This writes to a \%s", "file", name='logger.b')
}

}
\seealso{
\code{\link{flog.logger}}, \code{\link{flog.threshold}},
\code{\link{flog.layout}}, \code{\link{flog.appender}}
}
\author{
Brian Lee Yung Rowe <r@zatonovo.com>
}
\keyword{attribute}
\keyword{logic}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logger.R
\name{flog.threshold}
\alias{flog.threshold}
\title{Get and set the threshold for a logger}
\arguments{
\item{threshold}{integer The new threshold for the given logger}

\item{name}{character The name of the logger}
}
\description{
The threshold affects the visibility of a given logger. When a log
statement is called, e.g. \code{flog.debug('foo')}, futile.logger
compares the threshold of the logger with the level implied in the
log command (in this case DEBUG). If the log level is at or higher
in priority than the logger threshold, a message will print.
Otherwise the command will silently return.
}
\section{Usage}{

# Get the threshold for the given logger\cr
flog.threshold(name) \%::\% character : character \cr
flog.threshold(name=ROOT)

# Set the threshold for the given logger\cr
flog.threshold(threshold, name=ROOT)
}

\examples{
flog.threshold(ERROR)
flog.info("Won't print")
flog.threshold(INFO)
flog.info("Will print")
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appender.R
\name{flog.appender}
\alias{flog.appender}
\alias{appender.console}
\alias{appender.file}
\alias{appender.file2}
\alias{appender.tee}
\alias{appender.modulo}
\alias{appender.graylog}
\alias{appender.syslog}
\title{Manage appenders for loggers}
\arguments{
\item{\dots}{Used internally by lambda.r}
}
\description{
Provides functions for adding and removing appenders.
}
\section{Usage}{

# Get the appender for the given logger\cr
flog.appender(name) \%::\% character : Function\cr
flog.appender(name='ROOT')

# Set the appender for the given logger\cr
flog.appender(fn, name='ROOT')

# Print log messages to the console\cr
appender.console()

# Write log messages to a file\cr
appender.file(file)

# Write log messages to a dynamically-named file\cr
appender.file2(format)

# Write log messages to console and a file\cr
appender.tee(file)

# Write log messages to a Graylog2 HTTP GELF endpoint\cr
appender.graylog(server, port)

# Write log message to syslog. Arguments are passed on to \code{\link[rsyslog]{open_syslog}}.\cr
appender.syslog(identifier, ...)

# Special meta appender that prints only when the internal counter mod n = 0\cr
appender.modulo(n, appender=appender.console())
}

\section{Details}{

Appenders do the actual work of writing log messages to some target.
To use an appender in a logger, you must register it to a given logger.
Use \code{flog.appender} to both access and set appenders.

The ROOT logger by default uses \code{appender.console}.

\code{appender.console} is a function that writes to the console.
No additional arguments are necessary when registering the appender 
via flog.appender.

\code{appender.file} writes to a file, so you must pass an additional file
argument to the function. To change the file name, just call
\code{flog.appender(appender.file(file))} again with a new file name.

\code{appender.file2} is similar, but the filename is dynamically
determined at runtime. It may include most of the same tokens as
\code{layout.format} (all except \code{"~m"}, the message
itself). This allows, for instance, having separate logfiles for
each log level.

To use your own appender create a function that takes a single argument,
which represents the log message. You need to pass a function reference to
\code{flog.appender}.

\code{appender.tee} writes to both the console and file.

\code{appender.graylog} writes to a Graylog2 HTTP GELF endpoint.

\code{appender.syslog} writes to the POSIX system logger.

\code{appender.modulo} is a meta appender. It calls \code{appender} every \code{n} times.
}

\section{Value}{

When getting the appender, \code{flog.appender} returns the appender
function.  When setting an appender, \code{flog.appender} has no 
return value.
}

\examples{
\dontrun{
flog.appender(appender.console(), name='my.logger')

# Set an appender to the logger named 'my.package'. Any log operations from
# this package will now use this appender.
flog.appender(appender.file('my.package.out'), 'my.package')

# Set an appender to a file named using the message level and calling function.
# Also tee the messages to the console.
flog.appender(appender.file2('~l-~f.log', console = TRUE))
}
}
\seealso{
\code{\link{flog.logger}} \code{\link{flog.layout}}
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scat.R
\name{scat}
\alias{scat}
\title{Print formatted messages}
\usage{
scat(format, ..., use.newline = TRUE)
}
\arguments{
\item{format}{A format string passed to sprintf}

\item{\dots}{Arguments to pass to sprintf for dereferencing}

\item{use.newline}{Whether to append a new line at the end}
}
\value{
A formatted string printed to the console
}
\description{
A replacement for \code{cat} that has built-in sprintf formatting
}
\details{
Like \code{cat} but you can use format strings.
}
\examples{

  apply(array(2:5),1, function(x) scat('This has happened \%s times', x) )

}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logger.R
\name{flog.remove}
\alias{flog.remove}
\title{Remove a logger}
\arguments{
\item{name}{The logger name to use}
}
\description{
In the event that you no longer wish to have a logger registered,
use this function to remove it. Then any references to this
logger will inherit the next available logger in the hierarchy.
}
\section{Usage}{

# Remove a logger\cr
flog.remove(name)
}

\examples{
flog.threshold(ERROR, name='my.logger')
flog.info("Won't print", name='my.logger')
flog.remove('my.logger')
flog.info("Will print", name='my.logger')
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/options.R
\name{logger.options}
\alias{logger.options}
\alias{FATAL}
\alias{ERROR}
\alias{WARN}
\alias{INFO}
\alias{DEBUG}
\alias{TRACE}
\title{Constants for 'futile.logger'}
\usage{
logger.options(..., simplify = FALSE, update = list())
}
\arguments{
\item{...}{TODO}

\item{simplify}{TODO}

\item{update}{TODO}
}
\description{
Log level constants and the logger options.
}
\details{
The logging configuration is managed by 'logger.options', a function
generated by OptionsManager within 'futile.options'.
}
\seealso{
\code{futile.options}
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logger.R
\name{flog.logger}
\alias{flog.logger}
\alias{flog.trace}
\alias{flog.debug}
\alias{flog.info}
\alias{flog.warn}
\alias{flog.error}
\alias{flog.fatal}
\title{Manage loggers}
\arguments{
\item{msg}{The message to log}

\item{name}{The logger name to use}

\item{capture}{Capture print output of variables instead of interpolate}

\item{logger}{The logger to use. If \code{NULL} (the default), it is 
looked up based on \code{name}. Provide \code{logger} explicitely if 
the speed of the evaluation of log level is of concern (e.g., a 
\code{flog.trace} call in your function which has to be run many times).}

\item{\dots}{Optional arguments to populate the format string}

\item{expr}{An expression to evaluate}

\item{finally}{An optional expression to evaluate at the end}
}
\description{
Provides functions for writing log messages and managing loggers. Typically
only the flog.[trace|debug|info|warn|error|fatal] functions need to be used
in conjunction with flog.threshold to interactively change the log level.
}
\section{Usage}{

# Conditionally print a log statement at TRACE log level
flog.trace(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)

# Conditionally print a log statement at DEBUG log level
flog.debug(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)

# Conditionally print a log statement at INFO log level
flog.info(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)

# Conditionally print a log statement at WARN log level
flog.warn(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)

# Conditionally print a log statement at ERROR log level
flog.error(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)

# Print a log statement at FATAL log level
flog.fatal(msg, ..., name=flog.namespace(), logger=NULL, capture=FALSE)

# Execute an expression and capture any warnings or errors
ftry(expr, error=stop, silent=FALSE, finally=NULL, details='')
}

\section{Additional Usage}{

These functions generally do not need to be called by an end user.

# Get the ROOT logger
flog.logger()

# Get the logger with the specified name
flog.logger(name)

# Set options for the given logger
flog.logger(name, threshold=NULL, appender=NULL, layout=NULL, carp=NULL)
}

\section{Details}{

These functions represent the high level interface to futile.logger.

The primary use case for futile.logger is to write out log messages. There
are log writers associated with all the predefined log levels: TRACE, DEBUG,
INFO, WARN, ERROR, FATAL. Log messages will only be written if the log level
is equal to or more urgent than the current threshold. By default the ROOT
logger is set to INFO.

> flog.debug("This won't print")
> flog.info("But this \%s", 'will')
> flog.warn("As will \%s", 'this')

Typically, the built in log level constants are used in the call, which
conform to the log4j levels (from least severe to most severe): TRACE,
DEBUG, INFO, WARN, ERROR, FATAL. It is not a strict requirement to use these
constants (any numeric value will work), though most users should find this
level of granularity sufficient.

Loggers are hierarchical in the sense that any requested logger that is
undefined will fall back to its most immediate defined parent logger. The
absolute parent is ROOT, which is guaranteed to be defined for the system
and cannot be deleted. This means that you can specify a new logger
directly.

> flog.info("This will fall back to 'my', then 'ROOT'", name='my.logger')

You can also change the threshold or any other setting associated with a
logger. This will create an explicit logger where any unspecified options
are copied from the parent logger.

> flog.appender(appender.file("foo.log"), name='my')
> flog.threshold(ERROR, name='my.logger')
> flog.info("This won't print", name='my.logger')
> flog.error("This %s print to a file", 'will', name='my.logger')

If you have a function which gets called many times, it is a good strategy 
to pass the logger directly instead of its name.

Instead of this:
> simulation_fun <- function(i) \{
>   flog.trace("We are in loop %d", i, name='my.logger')
>   i
> \}

... you can do this::
> my_logger <- flog.logger("my.logger")
> simulation_fun2 <- function(i) \{
>   flog.trace("We are in loop %d", i, logger=my_logger)
>   i
> \}

> system.time(for (i in 1:1000) simulation_fun(i))
> system.time(for (i in 1:1000) simulation_fun2(i))

If you define a logger that you later want to remove, use flog.remove.

The option 'capture' allows you to print out more complicated data
structures without a lot of ceremony. This variant doesn't accept format
strings and instead appends the value to the next line of output. Consider 

> m <- matrix(rnorm(12), nrow=3) \cr
> flog.info("Matrix:",m, capture=TRUE)

which preserves the formatting, whereas using capture=FALSE will have 
a cluttered output due to recycling.
}

\examples{

flog.threshold(DEBUG)
flog.debug("This debug message will print")

flog.threshold(WARN)
flog.debug("This one won't")

m <- matrix(rnorm(12), nrow=3)
flog.info("Matrix:",m, capture=TRUE)

ftry(log(-1))

\dontrun{
s <- c('FCX','AAPL','JPM','AMZN')
p <- TawnyPortfolio(s)

flog.threshold(TRACE,'tawny')
ws <- optimizePortfolio(p, RandomMatrixDenoiser())
z <- getIndexComposition()

flog.threshold(WARN,'tawny')
ws <- optimizePortfolio(p, RandomMatrixDenoiser())
z <- getIndexComposition()
}

\dontrun{
flog.appender(appender.modulo(1000), name='counter')
lapply(1:10000, function(i) flog.info("value is \%s",i, name='counter'))
}
}
\seealso{
\code{\link{flog.threshold}} \code{\link{flog.remove}}
\code{\link{flog.carp}} \code{\link{flog.appender}} \code{\link{flog.layout}}
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/layout.R
\name{flog.layout}
\alias{flog.layout}
\alias{layout.simple}
\alias{layout.simple.parallel}
\alias{layout.format}
\alias{layout.tracearg}
\alias{layout.json}
\alias{layout.graylog}
\alias{layout.glue}
\alias{layout.colored}
\title{Manage layouts within the 'futile.logger' sub-system}
\arguments{
\item{\dots}{Used internally by lambda.r}
}
\description{
Provides functions for managing layouts. Typically 'flog.layout' is only
used when manually creating a logging configuration.
}
\section{Usage}{

# Get the layout function for the given logger\cr
flog.layout(name) \%::\% character : Function\cr
flog.layout(name='ROOT')

# Set the layout function for the given logger\cr
flog.layout(fn, name='ROOT')

# Decorate log messages with a standard format\cr
layout.simple(level, msg, ...)

# Decorate log messages with a standard format colored by log level\cr
layout.colored(level, msg, ...)

# Decorate log messages with a standard format using glue instead of sprintf\cr
layout.glue(level, msg, ...)

# Decorate log messages with a standard format and a pid\cr
layout.simple.parallel(level, msg, ...)

# Generate log messages as JSON\cr
layout.json(level, msg, ...)

# Decorate log messages using a custom format\cr
layout.format(format, datetime.fmt="%Y-%m-%d %H:%M:%S")

# Show the value of a single variable
layout.tracearg(level, msg, ...)

# Generate log messages in a Graylog2 HTTP GELF accetable format
layout.graylog(common.fields)
}

\section{Details}{

Layouts are responsible for formatting messages so they are human-readable.
Similar to an appender, a layout is assigned to a logger by calling 
\code{flog.layout}. The \code{flog.layout} function is used internally
to get the registered layout function. It is kept visible so 
user-level introspection is possible.

\code{layout.simple} is a pre-defined layout function that 
prints messages in the following format:\cr
  LEVEL [timestamp] message

This is the default layout for the ROOT logger.

\code{layout.format} allows you to specify the format string to use 
in printing a message. The following tokens are available.
\describe{
\item{~l}{Log level}
\item{~t}{Timestamp}
\item{~n}{Namespace}
\item{~f}{The calling function}
\item{~m}{The message}
\item{~p}{The process PID}
\item{~i}{Logger name}
}

\code{layout.json} converts the message and any additional objects provided
to a JSON structure. E.g.:

flog.info("Hello, world", cat='asdf')
 
yields something like

\{"level":"INFO","timestamp":"2015-03-06 19:16:02 EST","message":"Hello, world","func":"(shell)","cat":["asdf"]\}

\code{layout.tracearg} is a special layout that takes a variable
and prints its name and contents.

\code{layout.graylog} is a special layout for use with the appender.graylog to
generate json acceptable to a Graylog2 HTTP GELF endpoint. Standard fields to
be included with every message can be included by setting the common.fields
to a list of properties. E.g.: 

flog.layout(layout.graylog(common.fields = list(host_ip = "10.10.11.23", 
                                                env = "production")))
}

\examples{
# Set the layout for 'my.package'
flog.layout(layout.simple, name='my.package')

# Update the ROOT logger to use a custom layout
layout <- layout.format('[~l] [~t] [~n.~f] ~m')
flog.layout(layout)

# Create a custom logger to trace variables
flog.layout(layout.tracearg, name='tracer')
x <- 5
flog.info(x, name='tracer')
}
\seealso{
\code{\link{flog.logger}} \code{\link{flog.appender}}
}
\author{
Brian Lee Yung Rowe
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/layout.R
\name{prepare_arg}
\alias{prepare_arg}
\title{Provide basic parsing for layout string}
\usage{
prepare_arg(x)
}
\arguments{
\item{x}{The argument to prepare}
}
\description{
Return name of argument if arg is empty. Otherwise return the value.
}
